# brightsign-nexus-image
#
# Image configuration for BrightSign based on Nexus
#

PR = "r3"
PACKAGE_ARCH = "${MACHINE}${BS_ALL_SUFFIXES}"
__BB_DONT_CACHE = "1"

# Bitbake's dependency checking doesn't seem to be working. If a
# package is rebuilt it won't necessarily rebuild the rootfs so let's
# force it.

do_rootfs[nostamp] = "1"

# This really means "don't install any static entries in /dev".
USE_DEVFS = "1"

TD_ONLY_PACKAGES = "crash-kernel"
DEBUG_PACKAGES = "strace gdbserver valgrind"
WIFI_DRIVER_PACKAGE = "bcm4323-driver"
WIFI_TOOLS_PACKAGE = "bcm4323-tools"
WIFI_PACKAGES = "wpa-supplicant ${WIFI_TOOLS_PACKAGE} ${WIFI_DRIVER_PACKAGE}"

WIFI_PACKAGES_tiger = ""
WIFI_PACKAGES_bcm97445 = ""

IMAGE_INSTALL = "base-files \
	         base-passwd \
		 busybox \
		 ca-certificates \
		 brightsign-apps \
		 brightsign-apps-check-for-update \
		 brightsign-apps-storage-monitor \
		 mtd-utils \
		 mtd-utils-ubifs \
		 brightsign-startup \
		 brightsign-startup-automount \
		 avahi \
		 util-linux-blkid \
		 dhcpcd \
		 dosfstools \
		 kernel-modules \
		 iperf \
		 iproute2 \
		 linuxptp \
		 tcpdump \
		 e2fsprogs-e2fsck e2fsprogs-mke2fs e2fsprogs-badblocks \
		 ${@base_conditional('BS_DEBUG', '1', '${DEBUG_PACKAGES}', '', d)} \
		 ${WIFI_PACKAGES} \
		 memtester \
		 net-snmp-server \
		 flashbench \
		 dfu-programmer \
		 ${@base_conditional('BS_TIMEDOCTOR', '1', '${TD_ONLY_PACKAGES}', '', d)} \
		 "

IMAGE_INSTALL_append_cheetah = " \
		 fontconfig-utils \
		 gdk-pixbuf-loader-png \
		 gdk-pixbuf-loader-jpeg \
		 gdk-pixbuf-loader-bmp \
		 kexec-tools \
"

IMAGE_INSTALL_append_puma = " \
                 brightsign-dora-fpga \
"

IMAGE_LINGUAS = ""

IMAGE_INSTALL += "curl"
IMAGE_INSTALL += "alsa-utils"

DEPENDS = "virtual/kernel"

LICENSE = "MIT"
LIC_FILES_CHKSUM = "file://${COREBASE}/LICENSE;md5=3f40d7994397109285ec7b81fdeb3b58 \
                    file://${COREBASE}/meta/COPYING.MIT;md5=3da9cfbcb788c80a0384361b4de20420"

IMAGE_DEPENDS_squashfs-signed = "${IMAGE_DEPENDS_squashfs}"

IMAGE_CMD_squashfs-signed() {
	${IMAGE_CMD_squashfs}
	${FILE_DIRNAME}/files/sign-squashfs.py ${BS_ROOTFS_PRIVATE_KEY} ${DEPLOY_DIR_IMAGE}/${IMAGE_NAME}.rootfs.squashfs
}

inherit image

IMAGE_CMD_ubi_bcm97445 () {
	echo \[writable\] > ubinize.cfg
	echo mode=ubi >> ubinize.cfg
	echo vol_id=0 >> ubinize.cfg
	echo vol_size=1MiB >> ubinize.cfg
	echo vol_type=dynamic >> ubinize.cfg
	echo vol_name=writable >>ubinize.cfg
	echo >> ubinize.cfg
	echo \[rootfs\] >> ubinize.cfg 
	echo mode=ubi >> ubinize.cfg
	echo image=${DEPLOY_DIR_IMAGE}/${IMAGE_NAME}.rootfs.ubifs >> ubinize.cfg 
	echo vol_id=1 >> ubinize.cfg 
	echo vol_type=dynamic >> ubinize.cfg 
	echo vol_name=${UBI_VOLNAME} >> ubinize.cfg 
	echo vol_size=150MiB >> ubinize.cfg
	mkfs.ubifs -r ${IMAGE_ROOTFS} -o ${DEPLOY_DIR_IMAGE}/${IMAGE_NAME}.rootfs.ubifs ${MKUBIFS_ARGS} && ubinize -o ${DEPLOY_DIR_IMAGE}/${IMAGE_NAME}.rootfs.ubi ${UBINIZE_ARGS} ubinize.cfg
}
